ushort
    VERSION1 = 1,	/* version 1.0 */
    VERSION2 = 2,
    COMMANDCOUNT = 62,	/* number of commands in command table */
    SECONDCHARCOUNT = 5,/* number of 2nd common escape chars allowed */
    NLINES = 24,	/* number of lines (doesn't use status line) */
    NCOLUMNS = 80;	/* number of columns displayable */

ushort
    REGIONCOL = 1,
    TEXTCOL = REGIONCOL + 2,
    INSERTCOL = TEXTCOL + 2,
    WRAPCOL = INSERTCOL + 2,
    MULTICOL = WRAPCOL + 2,
    SEARCHCOL = MULTICOL + 2,
    CHANGECOL = SEARCHCOL + 2,
    BUFFERCOL = CHANGECOL + 2,
    LINECOL = BUFFERCOL + 15,
    COLCOL = LINECOL + 5,
    ERRORCOL = COLCOL + 3;

ushort
    SEARCHLENGTH = NCOLUMNS - ERRORCOL - 1,
    DEFAULTINDENTINCREMENT = 4,		/* amount of each indent unit */
    DEFAULTWRAPCOLUMN = NCOLUMNS - 1;	/* column to word wrap at */

char
    BEEP = '\(0x07)';

type
    LINELIST = struct {
	*LINELIST l_next;
	*LINELIST l_prev;
	*char l_data;
    },

    TABMODE = enum {BLANKS, TABS, COUNTS},

    BUFFERLIST = struct {
	*BUFFERLIST
	    b_next,			/* pointer to previous buffer */
	    b_prev;			/* pointer to next buffer */
	*LINELIST b_lines;		/* head of list of lines */
	*LINELIST b_currentLine;	/* pointer to line for current */
	*char b_fileName;		/* name of file being edited */
	word
	    b_lineCount,		/* number of lines in file */
	    b_cursorLine;		/* line in file the cursor is in */
	ushort
	    b_cursorColumn,		/* column in line the cursor is in */
	    b_screenLine,		/* line on screen the cursor is on */
	    b_indentAmount,		/* amount of current auto-indent */
	    b_indentIncrement,		/* amount of each indent step */
	    b_wrapColumn;		/* column to do word-wrap at */
	TABMODE b_tabMode;		/* how to handle tabs in file */
	bool
	    b_isFile,			/* true if has associated file */
	    b_newFile,			/* true => edit file is a new file */
	    b_insertMode,		/* true => typing in insert mode */
	    b_wrapMode,			/* true => wrap at b_wrapColumn */
	    b_multiColumn;		/* true => multi-column enabled */
    },

    STATUS = enum {NORMAL, NEWFILEEXIT, NEWFILEQUIT, EXIT, QUIT},

    COMMANDENTRY = struct {
	ushort c_mode;
	char c_char;
    },

    COMMANDTABLE = struct {
	ushort c_secondCount;
	char c_escapeA;
	char c_escapeB;
	[SECONDCHARCOUNT] char c_escape2;
	[COMMANDCOUNT] COMMANDENTRY c_commands;
    };

*COMMANDTABLE CommandTable;		/* table of commands codes */

*BUFFERLIST BufferList;			/* list of active buffers */
BUFFERLIST CurrentBuffer;		/* copy of current buffer */

channel input text Chin;		/* channel to read files */
channel output text Chout @ Chin;	/* channel to write files */
file() Fyle;				/* file for disk I/O */

[NCOLUMNS] char LineBuffer;		/* buffer for line operations */
[NCOLUMNS] char TempBuffer;		/* buffer for scratch purposes */
[SEARCHLENGTH] char Subject;		/* subject string for searching */
[SEARCHLENGTH] char Object;		/* 'to' string for change */
[NCOLUMNS] bool TabStops;		/* logical tabstops */

FILENAME TempFileName @ TempBuffer;	/* filename for some file op'ns */

word RegionLine;			/* line of first end */

ushort
    RegionColumn,			/* column of first end */
    LineLength,				/* length of line in LineBuffer */
    SubjectLength,			/* length of search subject */
    MessageLength;			/* length of error message */

*LINELIST
    RegionPtr,				/* pointer to line of first end */
    TextLines;				/* lines yanked out of file */

*char
    TextChars,				/* line portion yanked out */
    CursorPos,				/* pointer to current character */
    RegionPos;				/* pointer to char of first end */

bool
    NoMemory,				/* true => op'n caused memory out */
    TooLong,				/* true => a line was too long */
    LineFixed,				/* true => line properly in list */
    LineChanged,			/* true => line has been changed */
    Searching,				/* true => have a search subject */
    Changing,				/* true => have a 'to' string */
    GotText,				/* true => have text text buffer */
    GotRegion;				/* true => have first region end */

STATUS CommandStatus;			/* status of command execution */
